# vim:ft=diff:
This is the trash folder patch by Cedric Duval <cedricduval@free.fr>.

With this patch, if the trash variable is set to a path (unset by default), the
deleted mails will be moved to a trash folder instead of being irremediably
purged when syncing the mailbox.

For instance, set trash="~/Mail/trash" will cause every deleted mail to go to
this folder.

Note that the append to the trash folder doesn't occur until the resync is
done. This allows you to change your mind and undo deletes, and thus the moves
to the trash folder are unnecessary.

Notes

    * You might also want to have a look at the purge message feature below
      which is related to this patch.
    * IMAP is now supported. To retain the previous behavior, add this to your
      muttrc:
      folder-hook ^imap:// 'unset trash'

FAQ

Every once in a while, someone asks what are the advantages of this patch over
a macro based solution. Here's an attempt to answer this question:

    * The folder history doesn't clutter up with unwanted trash entries.
    * Delayed move to the trash allows to change one's mind.
    * No need to treat the case of "normal folders" and trash folders
      separately with folder-hooks, and to create two sets of macros (one for
      the index, one for the pager).
    * Works not only with delete-message, but also with every deletion
      functions like delete-pattern, delete-thread or delete-subthread.

To sum up, it's more integrated and transparent to the user.

* Patch last synced with upstream:
  - Date: 2007-02-15
  - File: http://cedricduval.free.fr/mutt/patches/download/patch-1.5.5.1.cd.trash_folder.3.4

* Changes made:
  - Updated to 1.5.13:
    - structure of _mutt_save_message changed (commands.c)
    - context of option (OPTCONFIRMAPPEND) changed (muttlib.c)
  - Fixed indentation of "appended" in mutt.h.

== END PATCH
Index: commands.c
===================================================================
--- trash.orig/commands.c	2006-12-12 14:15:02.000000000 +0100
+++ commands.c	2007-02-15 19:34:10.324888040 +0100
@@ -690,6 +690,7 @@ int _mutt_save_message (HEADER *h, CONTE
     if (option (OPTDELETEUNTAG))
       mutt_set_flag (Context, h, M_TAG, 0);
   }
+  mutt_set_flag (Context, h, M_APPENDED, 1);
   
   return 0;
 }
Index: flags.c
===================================================================
--- trash.orig/flags.c	2006-12-12 14:15:02.000000000 +0100
+++ flags.c	2007-02-15 19:34:10.325887888 +0100
@@ -66,7 +66,13 @@ void _mutt_set_flag (CONTEXT *ctx, HEADE
       else if (h->deleted)
       {
 	h->deleted = 0;
-	if (upd_ctx) ctx->deleted--;
+	if (upd_ctx)
+	{
+	  ctx->deleted--;
+	  if (h->appended)
+	    ctx->appended--;
+	}
+	h->appended = 0; /* when undeleting, also reset the appended flag */
 #ifdef USE_IMAP
         /* see my comment above */
 	if (ctx->magic == M_IMAP) 
@@ -88,6 +94,17 @@ void _mutt_set_flag (CONTEXT *ctx, HEADE
       }
       break;
 
+    case M_APPENDED:
+      if (bf)
+      {
+	if (!h->appended)
+	{
+	  h->appended = 1;
+	  if (upd_ctx) ctx->appended++;
+	}
+      }
+      break;
+
     case M_NEW:
 
       if (!mutt_bit_isset(ctx->rights,M_ACL_SEEN))
Index: globals.h
===================================================================
--- trash.orig/globals.h	2007-01-04 15:23:49.000000000 +0100
+++ globals.h	2007-02-15 19:34:10.325887888 +0100
@@ -135,6 +135,7 @@ WHERE char *StChars;
 WHERE char *Status;
 WHERE char *Tempdir;
 WHERE char *Tochars;
+WHERE char *TrashPath;
 WHERE char *Username;
 WHERE char *Visual;
 
Index: imap/message.c
===================================================================
--- trash.orig/imap/message.c	2007-02-14 15:32:38.000000000 +0100
+++ imap/message.c	2007-02-15 19:34:10.325887888 +0100
@@ -817,6 +817,7 @@ int imap_copy_messages (CONTEXT* ctx, HE
         if (ctx->hdrs[n]->tagged)
         {
           mutt_set_flag (ctx, ctx->hdrs[n], M_DELETE, 1);
+	  mutt_set_flag (ctx, ctx->hdrs[n], M_APPENDED, 1);
           if (option (OPTDELETEUNTAG))
             mutt_set_flag (ctx, ctx->hdrs[n], M_TAG, 0);
         }
@@ -824,6 +825,7 @@ int imap_copy_messages (CONTEXT* ctx, HE
     else
     {
       mutt_set_flag (ctx, h, M_DELETE, 1);
+      mutt_set_flag (ctx, h, M_APPENDED, 1);
       if (option (OPTDELETEUNTAG))
         mutt_set_flag (ctx, h, M_TAG, 0);
     }
Index: init.h
===================================================================
--- trash.orig/init.h	2006-12-12 14:15:03.000000000 +0100
+++ init.h	2007-02-15 19:34:10.326887736 +0100
@@ -2808,6 +2808,16 @@ struct option_t MuttVars[] = {
   ** by \fIyou\fP.  The sixth character is used to indicate when a mail
   ** was sent to a mailing-list you subscribe to (default: L).
   */
+  { "trash",		DT_PATH, R_NONE, UL &TrashPath, 0 },
+  /*
+  ** .pp
+  ** If set, this variable specifies the path of the trash folder where the
+  ** mails marked for deletion will be moved, instead of being irremediably
+  ** purged.
+  ** .pp
+  ** NOTE: When you delete a message in the trash folder, it is really
+  ** deleted, so that you have a way to clean the trash.
+  */
 #ifdef USE_SOCKET
   { "tunnel",            DT_STR, R_NONE, UL &Tunnel, UL 0 },
   /*
Index: mutt.h
===================================================================
--- trash.orig/mutt.h	2007-01-04 15:23:49.000000000 +0100
+++ mutt.h	2007-02-15 19:34:10.327887584 +0100
@@ -200,6 +200,7 @@ enum
   M_DELETE,
   M_UNDELETE,
   M_DELETED,
+  M_APPENDED,
   M_FLAG,
   M_TAG,
   M_UNTAG,
@@ -703,6 +704,7 @@ typedef struct header
   unsigned int mime : 1;    		/* has a MIME-Version header? */
   unsigned int flagged : 1; 		/* marked important? */
   unsigned int tagged : 1;
+  unsigned int appended : 1;		/* has been saved */
   unsigned int deleted : 1;
   unsigned int changed : 1;
   unsigned int attach_del : 1; 		/* has an attachment marked for deletion */
@@ -873,6 +875,7 @@ typedef struct
   int new;			/* how many new messages? */
   int unread;			/* how many unread messages? */
   int deleted;			/* how many deleted messages */
+  int appended;                 /* how many saved messages? */
   int flagged;			/* how many flagged messages */
   int msgnotreadyet;		/* which msg "new" in pager, -1 if none */
 #if defined USE_POP || defined USE_IMAP
Index: muttlib.c
===================================================================
--- trash.orig/muttlib.c	2007-01-04 15:23:50.000000000 +0100
+++ muttlib.c	2007-02-15 19:34:10.327887584 +0100
@@ -1265,7 +1265,9 @@ int mutt_save_confirm (const char *s, st
 
   if (magic > 0 && !mx_access (s, W_OK))
   {
-    if (option (OPTCONFIRMAPPEND))
+    if (option (OPTCONFIRMAPPEND) &&
+	(!TrashPath || (mutt_strcmp (s, TrashPath) != 0)))
+      /* if we're appending to the trash, there's no point in asking */
     {
       snprintf (tmp, sizeof (tmp), _("Append messages to %s?"), s);
       if ((rc = mutt_yesorno (tmp, M_YES)) == M_NO)
Index: mx.c
===================================================================
--- trash.orig/mx.c	2006-12-12 14:15:03.000000000 +0100
+++ mx.c	2007-02-15 19:34:10.328887432 +0100
@@ -822,6 +822,53 @@ static int sync_mailbox (CONTEXT *ctx, i
   return rc;
 }
 
+/* move deleted mails to the trash folder */
+static int trash_append (CONTEXT *ctx)
+{
+    CONTEXT *ctx_trash;
+    int i = 0;
+    struct stat st, stc;
+
+    if (!TrashPath || !ctx->deleted ||
+	(ctx->magic == M_MAILDIR && option (OPTMAILDIRTRASH)))
+      return 0;
+
+    for (;i < ctx->msgcount && (!ctx->hdrs[i]->deleted ||
+				ctx->hdrs[i]->appended); i++);
+    if (i == ctx->msgcount)
+      return 0; /* nothing to be done */
+
+    if (mutt_save_confirm (TrashPath, &st) != 0)
+    {
+      mutt_error _("message(s) not deleted");
+      return -1;
+    }
+
+    if (lstat (ctx->path, &stc) == 0 && stc.st_ino == st.st_ino
+	&& stc.st_dev == st.st_dev && stc.st_rdev == st.st_rdev)
+      return 0;  /* we are in the trash folder: simple sync */
+
+    if ((ctx_trash = mx_open_mailbox (TrashPath, M_APPEND, NULL)) != NULL)
+    {
+      for (i = 0 ; i < ctx->msgcount ; i++)
+	if (ctx->hdrs[i]->deleted && !ctx->hdrs[i]->appended
+	    && mutt_append_message (ctx_trash, ctx, ctx->hdrs[i], 0, 0) == -1)
+	  {
+	    mx_close_mailbox (ctx_trash, NULL);
+	    return -1;
+	  }
+
+      mx_close_mailbox (ctx_trash, NULL);
+    }
+    else
+    {
+      mutt_error _("Can't open trash folder");
+      return -1;
+    }
+
+    return 0;
+}
+
 /* save changes and close mailbox */
 int mx_close_mailbox (CONTEXT *ctx, int *index_hint)
 {
@@ -957,6 +1004,7 @@ int mx_close_mailbox (CONTEXT *ctx, int 
 	  if (mutt_append_message (&f, ctx, ctx->hdrs[i], 0, CH_UPDATE_LEN) == 0)
 	  {
 	    mutt_set_flag (ctx, ctx->hdrs[i], M_DELETE, 1);
+	    mutt_set_flag (ctx, ctx->hdrs[i], M_APPENDED, 1);
 	  }
 	  else
 	  {
@@ -978,6 +1026,14 @@ int mx_close_mailbox (CONTEXT *ctx, int 
     return 0;
   }
   
+  /* copy mails to the trash before expunging */
+  if (purge && ctx->deleted)
+    if (trash_append (ctx) != 0)
+    {
+      ctx->closing = 0;
+      return -1;
+    }
+
 #ifdef USE_IMAP
   /* allow IMAP to preserve the deleted flag across sessions */
   if (ctx->magic == M_IMAP)
@@ -1173,6 +1229,12 @@ int mx_sync_mailbox (CONTEXT *ctx, int *
   msgcount = ctx->msgcount;
   deleted = ctx->deleted;
 
+  if (purge && ctx->deleted)
+  {
+    if (trash_append (ctx) == -1)
+      return -1;
+  } 
+
 #ifdef USE_IMAP
   if (ctx->magic == M_IMAP)
     rc = imap_sync_mailbox (ctx, purge, index_hint);
Index: postpone.c
===================================================================
--- trash.orig/postpone.c	2006-12-12 14:15:03.000000000 +0100
+++ postpone.c	2007-02-15 19:34:10.328887432 +0100
@@ -279,6 +279,9 @@ int mutt_get_postponed (CONTEXT *ctx, HE
   /* finished with this message, so delete it. */
   mutt_set_flag (PostContext, h, M_DELETE, 1);
 
+  /* and consider it saved, so that it won't be moved to the trash folder */
+  mutt_set_flag (PostContext, h, M_APPENDED, 1);
+
   /* update the count for the status display */
   PostCount = PostContext->msgcount - PostContext->deleted;
 
Index: PATCHES
===================================================================
--- PATCHES.orig	2007-02-15 19:35:06.277381968 +0100
+++ PATCHES	2007-02-15 19:35:06.277381968 +0100
@@ -0,0 +1 @@
+patch-1.5.13.cd.trash_folder.3.4
